% states: d, v, w
close all
clear all
clear yalmip
car_platoon_yalmip
ncars = 3;
car_length=4;
showu = true;
scenario = 2;
%x0 = [5; 8; 8];
x0 = [4; 2; 2];
X = cell(1, ncars);
U = cell(1, ncars);
for i = 1:ncars
    X{i} = x0';
end

%speed_ref_target = kron([2; 8; 11; 7; 8], ones(15, 1));
%speed_ref_target = kron([4; 8; 5; 7; 0], ones(15, 1));
speed_ref_target = kron([8; 10; 13; 11; 14], ones(15, 1));
%speed_ref_target = kron([5; 7; 9; 8; 7], ones(15, 1));
%speed_ref_target = kron([2; 4; 5; 4; 5], ones(15, 1));

f = tf(1, [1 1]);
speed_ref_target = lsim(f, speed_ref_target, 1:length(speed_ref_target));

speed_ref_target2 = kron([4; 0; 5; 7; 0], ones(15, 1));
speed_ref_target2 = lsim(f, speed_ref_target2, 1:length(speed_ref_target2));

%distance_ref_f1 = kron([5; 10; 3], ones(25, 1));
distance_ref_f1 = kron([6; 10; 7], ones(25, 1));
 distance_ref_other = kron([0.8*car_length; 0.8*car_length; 0.8*car_length], ones(25, 1));
%distance_ref_other = 8*ones(75, 1);
%distance_ref_other = kron([0.35*car_length; 0.35*car_length; 0.35*car_length],ones(25, 1));
%distance_ref_other = kron([0.1336*car_length; 0.1336*car_length; 0.1336*car_length],ones(25, 1));
%distance_ref_other = kron([6; 10; 7],ones(25, 1));
if scenario==2
    %distance_ref_f1 = 8*ones(75, 1);
      distance_ref_f1 = 4*ones(75, 1);
elseif scenario==3
    speed_ref_target = 14*ones(75, 1);
end

for k = 1:length(speed_ref_target)
    xn = cell(1, ncars);

     
         
    for i = 1:ncars
        if i==1
            xc = [X{1}(end, 1:2)'; speed_ref_target(k)];
            if isa(ctrl, 'optimizer')
                u = ctrl{[xc; distance_ref_f1(k)]};
            else
                u = ctrl([xc; distance_ref_f1(k)]);
            end
                
        else
            xc = [X{i}(end, 1:2)'; X{i-1}(end, 2)];
            if isa(ctrl, 'optimizer'),
                u = ctrl{[xc; distance_ref_other(k)]};
            else
                u = ctrl([xc; distance_ref_other(k)]);
            end
        end
        if any(isnan(u))
            error('Problem is infeasible.');
        end
    
        
        xn{i} = model.A*xc+model.B*u;
        xn{i}(xn{i}<0)=0;
        U{i} = [U{i}; u];
    end
    for i = 1:ncars
        X{i} = [X{i}; xn{i}'];
    end
    
%      if k>=15 && k<=20
%          X{2}(end, 2) = speed_ref_target2(k);
%      end
% %  
  

end

% prepare enough data for plotting
speed_ref_target = [speed_ref_target; speed_ref_target(end)];
distance_ref_f1 = [distance_ref_f1; distance_ref_f1(end)];
distance_ref_other = [distance_ref_other; distance_ref_other(end)];
for i = 1:ncars
    U{i} = [U{i}; U{i}(end)];
end
t = 0:length(speed_ref_target)-1;

%close all

if showu
    np = 3;
else
    np = 2;
end

for i = 1:ncars
    if i==1
        dref = distance_ref_f1;
    else
        dref = distance_ref_other;
    end
    
    figure
    subplot(np, 1, 1);
    plot(t, dref, 'r--', t, X{i}(:, 1), 'b', 'linewidth', 2);
    xlabel('k'),ylabel('vzdialenost[m]');
    %legend('Ziadana vzdialenost', 'Vzdialenost');
    title(sprintf('Auto %d', i));
    grid on
    
    subplot(np, 1, 2);
    plot(t, X{i}(:, 3), 'r--', t, X{i}(:, 2), 'b', 'linewidth', 2);
    %legend('Ziadana rychlost', 'Rychlost');
    xlabel('k'),ylabel('rychlost[m/s]');
    title(sprintf('Auto %d', i));
    grid on
   
    if showu
        subplot(np, 1, 3);
        plot(t, U{i}, 'b', 'linewidth', 2);
        xlabel('k'),ylabel('zrychlenie[m/s^2]');
        %legend('Zrychlenie');
        title(sprintf('Auto %d', i));
        grid on
    end
end

akc=0;
IAE=0;
for i=1:ncars
akc=akc+sum(U{i}(U{i}>0));
 IAE=IAE+sum(X{i}(:,1)-distance_ref_other);
end
akc
IAE
